extern "C" void f_flags(BI, double *, int *, int *, int *,
        int *, int *, int *, int *, double *, int *, double *);


class BHmask {

public:

Array(1)<int> *nl;
GridFunction(DIM)<double> *mask;
Array(1)<int> **m;
Array(1)<double> **d;

BHmask(GridHierarchy &GH, int SpaceStensil, int TimeStensil) {
      //   ADMscalar *x, ADMscalar *y, ADMscalar *z, 
      //   ADMscalar *r, double params[100], 
      //   int me) {


         int c;
         int Level=0;
         int t = CurrentTime(GH,Level,DAGH_Main);
         int tm1 = t - TimeStep(GH,Level,DAGH_Main);

         if(TimeStensil != 1) {
           cout << "BHmask called with TimeStencil != 1" << endl;
           exit(0);
	 }

         mask = new GridFunction(DIM)<double>("mask",TimeStensil,SpaceStensil,
                     GH,COMM,NO_SHADOW);
//         SetTimeAlias(*mask,1,-1);
         int comps = (*mask).len();
cout << "number of components " << comps << endl << flush;       
	 Array(1)<int> **mth = new Array(1)<int>*[comps];
         Array(1)<double> **dth = new Array(1)<double>*[comps];
         Array(1)<int> *nlth = new Array(1)<int>(0,comps);

	 GridFunction(DIM)<double> &st = *mask;


//         if(me==0) cout << "call horizon" << endl;

         forall (st,t,Level,c) {
//           horizon(FBA(st(t,Level,c,DAGH_Main)), 
//                  (*(*r).spacetime[0])(t,Level,c,DAGH_Main).data(),
//                  (*(*x).spacetime[0])(t,Level,c,DAGH_Main).data(),
//                  (*(*y).spacetime[0])(t,Level,c,DAGH_Main).data(),
//                  (*(*z).spacetime[0])(t,Level,c,DAGH_Main).data(),
//                  params, 
//                  (*mask)(t,Level,c,DAGH_Main).data(),
//                  (*mask)(tm1,Level,c,DAGH_Main).data(),
//                   &me);

           mth[c] = new Array(1)<int>(0,MAXNLM);
           dth[c] = new Array(1)<double>(0,MAXNLD);
           nlth[c]=0; 

         } end_forall; 

         nl=nlth;
	 d = dth;
         m = mth;
  };
  void flags(double *params) {
         int c;
         int t = 0;
         int Level=0;

         GridFunction(DIM)<double> &st = *mask;
         int *ntmp = (*nl).data();
         forall (st,t,Level,c) {
           int n=ntmp[c];
           f_flags(FBA((*mask)(t,Level,c,DAGH_Main)),
                   FDA((*mask)(t,Level,c,DAGH_Main)),
                   FBA(*m[c]),FBA(*d[c]),
                   FDA(*m[c]),FDA(*d[c]), &n, params);
                   ntmp[c]=n;
         cout << "# mask points " << c << ": " << n << endl;
         }end_forall;
  };
};

